﻿--[[
		Xer0X (tm) CopyLeft (c) 2019 
	    Super Ultra Extra Total Dialogs & Panels 
		Auto ReXiZeR (tm) & MuVvier (tm) 

	Resizes and moves all the Far Manager dialogs 
			with ease!
	-----------------------------------------------

	With love and devotion, to those brave people 
	who is dare enough for use Far Manager in 2020 
	-----------------------------------------------

	DISCLAIMER
	The script's administration is not responsible 
	for  any  use, or  misuse,  or  any  kind  of 
	unexpected  or  disappointing   behaviour 
	while running  the  supplied  script.
	Use  carefully  on  your  own responsibility.
	-----------------------------------------------

--]]

--[[	TODO SECTION: 

1.)	move configs above to ini-file

2.) 	add dialog/window GUIDs not to resize

3.) 	add specific handling to dialog/windows by it's GUIDs, 
	i.e. apply certain rules to specific guids, 
	as for example: 
		a.) this windows (guids) always put in full screen
		b.) those do not ever touch
		c.) .. etc .. ?

4.)	probably, improve isolation between windows types, currently it MAY interfere each other
	that is not critical, since switchin by F5 seems to work flawlessly

5.)	add more modes ? as for example 60%, 70%, 80%, 90% ?

6.)	to write thorough documentation to help people find it and use it

7.)	(to fix) Too complex dialogs with many elements also hidden, 
	as for example "plugin configuration/netbox/transfer settings"
	we are still not perfect.

8.)	Probably fix to disk menu going centered

9.)	Probably clean up the code related to performance, i.e. do not call resize dialog routine, when we only moving the dialog

--	END OF TODO SECTION	--]]


-- #################################


--[[	SETTINGS SECTION	--]]

local layout_sizing_type_start = "original" 
-- "margin" ==> "full" ==> "original" ==> custom (if have) ==> "percent" ==> "margin" ==> "full" ==> (.. and so on)

local layout_margin_width = 4
local layout_percent_width = 70
local layout_custom_width = -1

--[[ END OF SETTINGS SECTION --]]

local _dlg_info_mcr,_dlg_info_evt, _hDlg, _hDlg_evt, _hDlg_mcr, _dlg_guid, _dlg_guid_evt, _dlg_guid_mcr, _evt, _layout_custom_cmd 
local _dlg_geometry_orig = {}
local _dlg_position_orig = {}
local _dlg_geometry_cust = {}
local _dlg_position_cust = {}
local _dlg_items_orig = {}
local _dlg_custom_width = {}
local _dlg_custom_X = {}
local _dlg_custom_Y = {}
local _dlg_layout_sizing_type = {}
local _dlg_custom_flag = {}

function _elem_is_inside_full(elem1, elem2) return
	elem2[2] <= elem1[2] and 
	elem2[3] <= elem1[3] and 
	elem2[4] >= elem1[4] and 
	elem2[5] >= elem1[5] 
end

local function _layout_state_machine(sender)
	_layout_custom_cmd = ""
	if not	_dlg_layout_sizing_type[_dlg_guid]
	then	_dlg_layout_sizing_type[_dlg_guid] =  layout_sizing_type_start 
	elseif	_dlg_layout_sizing_type[_dlg_guid] == "margin" 
	then	_dlg_layout_sizing_type[_dlg_guid] =  "full" 
	elseif	_dlg_layout_sizing_type[_dlg_guid] == "full" 
	then	_dlg_layout_sizing_type[_dlg_guid] =  "original" 
	elseif	_dlg_layout_sizing_type[_dlg_guid] == "original" and _dlg_custom_flag[_dlg_guid]
	then	_dlg_layout_sizing_type[_dlg_guid] =  "custom" 
	elseif	_dlg_layout_sizing_type[_dlg_guid] == "original" 
	then	_dlg_layout_sizing_type[_dlg_guid] =  "percent" 
	elseif	_dlg_layout_sizing_type[_dlg_guid] == "custom" 
	then	_dlg_layout_sizing_type[_dlg_guid] =  "percent" 
	elseif	_dlg_layout_sizing_type[_dlg_guid] == "percent" 
	then	_dlg_layout_sizing_type[_dlg_guid] =  "margin" 
	end
end

function _resize(sender, msg) 
	local cons_geometry = far.AdvControl("ACTL_GETFARRECT")
	local cons_width = cons_geometry.Right - cons_geometry.Left + 1
	local cons_height = cons_geometry.Bottom - cons_geometry.Top + 1
	local dlg_geometry = -- two methods of doing the same: 
	--	_hDlg:send(far.Flags.DM_GETDLGRECT,0,0)
		far.SendDlgMessage(_hDlg, far.Flags.DM_GETDLGRECT)
	local rest_orig = false
	local cust_conf = false
	if _dlg_geometry_orig[_dlg_guid] == nil or sender == "event" and msg == far.Flags.DN_INITDIALOG 
	then 
		_layout_custom_cmd = "" 
		if not _dlg_layout_sizing_type[_dlg_guid] then 
			_layout_state_machine(sender) 
		end 
		_dlg_geometry_orig[_dlg_guid] = dlg_geometry;
		_dlg_position_orig[_dlg_guid] = dlg_position;
		_dlg_items_orig[_dlg_guid] = {}
		local ii
		for dlgii = 0, 1000, 1 do 
			dlgi = far.GetDlgItem(_hDlg, dlgii)
			if dlgi then ii = dlgi 
			_dlg_items_orig[_dlg_guid][dlgii] = dlgi; 
			elseif ii then break; end 
		end
	end 

	local orig_width = _dlg_geometry_orig[_dlg_guid].Right - _dlg_geometry_orig[_dlg_guid].Left + 1 
	local orig_height = _dlg_geometry_orig[_dlg_guid].Bottom - _dlg_geometry_orig[_dlg_guid].Top + 1 
	local curr_width = dlg_geometry.Right - dlg_geometry.Left + 1
	local curr_height = dlg_geometry.Bottom - dlg_geometry.Top + 1
	local targ_width 

	if _layout_custom_cmd and _layout_custom_cmd ~= "" 
	then -- incremental interactive manipulations
		local size_new = {X = curr_width, Y = curr_height}
		local location_new = {X = 0, Y = 0}
		if	_layout_custom_cmd == "AltRight" 
		then	size_new.X = size_new.X + 2
			location_new.X = -1
		elseif	_layout_custom_cmd == "AltLeft" 
		then	size_new.X = size_new.X - 2
			location_new.X = 1
		elseif	_layout_custom_cmd == "CtrlAltRight" 
		then	location_new.X = 1
		elseif	_layout_custom_cmd == "CtrlAltLeft" 
		then	location_new.X = -1
		elseif	_layout_custom_cmd == "CtrlAltUp" 
		then	location_new.Y = -1
		elseif	_layout_custom_cmd == "CtrlAltDown" 
		then	location_new.Y = 1
		end

		_dlg_position_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_MOVEDIALOG, 0, location_new)
		_dlg_geometry_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_RESIZEDIALOG, 0, {X = size_new.X, Y = size_new.Y})

		_dlg_position_cust[_dlg_guid] = _dlg_position_curr
		_dlg_geometry_cust[_dlg_guid] = _dlg_geometry_curr

		targ_width = _dlg_geometry_curr.X 

		_dlg_layout_sizing_type[_dlg_guid] = "custom" 
		_dlg_custom_flag[_dlg_guid] = true
	--	if targ_width == curr_width then return false; end

	else -- config by layout type: 
		if 	_dlg_layout_sizing_type[_dlg_guid] == "margin" 
		then 	targ_width = cons_width - layout_margin_width 
		elseif	_dlg_layout_sizing_type[_dlg_guid] == "percent" 
		then	targ_width = cons_width * layout_percent_width / 100 
		elseif	_dlg_layout_sizing_type[_dlg_guid] == "full" 
		then	targ_width = cons_width 
		elseif	_dlg_layout_sizing_type[_dlg_guid] == "custom" and _dlg_custom_flag[_dlg_guid] 
		then	targ_width = _dlg_geometry_cust[_dlg_guid].X 
			cust_conf = true
		elseif	_dlg_layout_sizing_type[_dlg_guid] == "original" 
		then	targ_width = orig_width
			rest_orig = true
		end 
		
		if rest_orig then 
			_dlg_position_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_MOVEDIALOG, 1, {X = _dlg_geometry_orig[_dlg_guid].Left,	Y = _dlg_geometry_orig[_dlg_guid].Top})
		elseif cust_conf then
			_dlg_position_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_MOVEDIALOG, 1, {X = _dlg_position_cust[_dlg_guid].X,	Y = _dlg_position_cust[_dlg_guid].Y})
		else 
			_dlg_position_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_MOVEDIALOG, 1, {X = (cons_width - targ_width) / 2,		Y = _dlg_geometry_orig[_dlg_guid].Top})
		end
		_dlg_geometry_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_RESIZEDIALOG, 0, {X = targ_width, Y = orig_height})
	end

	local delta_width = targ_width - curr_width
	local max_height, dlgi, dlgi_new = 0, nil, nil
	for dlgii = 0, 1000, 1 do 
		dlgi = far.GetDlgItem(_hDlg, dlgii)
		if not dlgi and dlgi_new then break; end
		dlgi_new = dlgi
		if dlgi then
			max_height = math.max(max_height, dlgi[5]) 
			local modified = false
			if rest_orig then 
				dlgi_new = _dlg_items_orig[_dlg_guid][dlgii] 
				if dlgi_new then modified = true end
			elseif dlgi[4] > 0 then 
				local targ_item_width = targ_width - dlgi[2] - 1
				--	= math.max(targ_width - dlgi[2] - 1, dlgi[4] + delta_width) 
				dlgi_next = far.GetDlgItem(_hDlg, dlgii + 1)
				if not dlgi_next or _elem_is_inside_full(dlgi_next, dlgi) or dlgi_next[3] > dlgi[3] 
				then	dlgi_new[4] = targ_item_width;
					modified = true
				end 
			end
			if modified then far.SetDlgItem(_hDlg, dlgii, dlgi_new) end
		end
	end
end
-- --[[
Event { description="";
	id = "3AFC2AA4-9638-4C59-8602-7A25ECD87126";
	group = "DialogEvent";
	condition = function(evt, fde) return true; end;
--	tFarDialogEvent:{hDlg,Msg,Param1,Param2}
	action = function(evt, fde) 

-- ###

-- to read keyboard event:
-- _dump_tbl(fde.Param2, "Fde.Msg:"..evt)

local key_F5 = evt == far.Flags.DE_DLGPROCEND and 
	fde.Msg == far.Flags.DN_CONTROLINPUT and 
	fde.Param2.EventType ==  far.Flags.KEY_EVENT and 
	fde.Param2.VirtualKeyCode == 116 -- VK_F5 

local dlg_init = evt == far.Flags.DE_DLGPROCINIT and fde.Msg == far.Flags.DN_INITDIALOG

if not dlg_init then return false; end
if not (key_F5 or dlg_init) then return false; end

local	dlg_info = far.SendDlgMessage(fde.hDlg, far.Flags.DM_GETDIALOGINFO)
if not	dlg_info then 
	dlg_info = far.AdvControl(far.Flags.ACTL_GETWINDOWINFO, nil) 
	if not dlg_info then return false; end 
end

if 	dlg_info.Id and 
	not dlg_info.TypeName and 
	type(dlg_info.Id) == "string" 
then 
	if pcall(function() dlg_guid = win.Uuid(dlg_info.Id):upper() end) then end 
	if dlg_guid == nil then dlg_guid = tostring(dlg_info.Id) end 
else 	
	dlg_guid = tostring(fde.hDlg)
end 

-- drop down box for free text:
if dlg_guid == "4406C688-209F-4378-8B7B-465BF16205FF" then return false; end

_dlg_guid = dlg_guid
_dlg_guid_evt = dlg_guid
_dlg_info_evt = dlg_info
_dlg_info = dlg_info 
_evt = evt 
_fde = fde 
_hDlg_evt = fde.hDlg
_hDlg = fde.hDlg
_layout_custom_cmd = ""
if 	key_F5  
then	_layout_state_machine("event") 
elseif	dlg_init
then
end 
_resize("event", fde.Msg)
return false; 

--- @@@

	end 
}

-- --[[

Macro { description = "Resize dialogs & other modal windows by F5";
	id = "B4536879-7071-4619-8F9C-6DBE59E3B6E2";
	area = "Other Dialog Menu MainMenu UserMenu Disks";
	key = [[CtrlAltRight	CtrlAltLeft	CtrlAltUp	CtrlAltDown 
		CtrlRAltRight 	CtrlRAltLeft	CtrlRAltUp	CtrlRAltDown 
		RCtrlRAltRight 	RCtrlRAltLeft	RCtrlRAltUp	RCtrlRAltDown 
		AltRight AltLeft F5]];
	condition = function(key) return true; end;
	priority = 1;
	action = function(...) 

--- ###

local dlg_guid = Area.Dialog and Dlg.Id or Menu.Id
-- drop down box for free text:
if dlg_guid == "4406C688-209F-4378-8B7B-465BF16205FF" then return false end

local dlg_info = far.AdvControl(far.Flags.ACTL_GETWINDOWINFO, nil)

_dlg_info_mcr = dlg_info;
_hDlg_mcr = _dlg_info_mcr.Id
_dlg_guid_mcr = dlg_guid

_dlg_guid = mf.iif(_dlg_info_mcr.Id == _fde.hDlg, _dlg_guid_evt, _dlg_guid_mcr)
_hDlg = _hDlg_mcr

if	akey(1, 0) == "F5" 
then	_layout_state_machine("macro")
else	_layout_custom_cmd = akey(1, 0):gsub("RAlt", "Alt"):gsub("RCtrl", "Ctrl")
end

_resize("macro")

--- @@@

	end;
}
--]]
